"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class FMap extends Map {
    constructor(entries) {
        super(entries);
    }
    map(fn, thisArg) {
        const nMap = new FMap();
        if (thisArg)
            fn = fn.bind(thisArg);
        for (let [k, v] of this) {
            nMap.set(k, fn(v, k, this));
        }
        return nMap;
    }
    filter(fn, thisArg) {
        const nMap = new FMap();
        if (thisArg)
            fn = fn.bind(thisArg);
        for (let [k, v] of this) {
            if (fn(v, k, this))
                nMap.set(k, v);
        }
        return nMap;
    }
    reduce(fn, initialValue) {
        let a = initialValue;
        for (let [k, v] of this) {
            a = fn(a, v, k, this);
        }
        return a;
    }
}
exports.default = FMap;
